SystemOrganization addCategory: #'Math-Tests-FunctionFit'!

TestCase subclass: #AnotherChromosomeManagerTest
	instanceVariableNames: 'cm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-FunctionFit'!

!AnotherChromosomeManagerTest methodsFor: 'running' stamp: 'wk 6/21/2014 11:36'!
setHammersleyTest: aBoolean
cm useHammersley: aBoolean.
cm randomizePopulation.
self assert: (cm isFullyPopulated ).
self assert: (cm population anySatisfy: [:g|g first >1]).
self assert: (cm population anySatisfy: [:g|g first <1]).
self assert: (cm population anySatisfy: [:g|g second  <2]).
self assert: (cm population anySatisfy: [:g|g second  >3]).
cm population do: [:i|self assert: (i size =2).self assert: (i first between: 0 and: 2).self assert: (i second  between: 1 and: 4)].! !

!AnotherChromosomeManagerTest methodsFor: 'running' stamp: 'wk 6/21/2014 09:47'!
setUp 
cm:=(AnotherChromosomeManager origin: #(0 1) range: #( 2 3)).! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'wk 6/21/2014 10:58'!
testAccessing
self assert: (cm range=#(2 3)).
self assert: (cm populationSize=100).
self deny: (cm isFullyPopulated ).! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 10:52'!
testCrossOver
|a|
1 to: 20 do: [:i| a:=cm crossover: #(1 2 3) and: #(4 5 6).
	1 to:2 do:[:index|
		self assert: (#(1 4) includes: ((a at: index) first)).
		self assert: (#(2 5)includes:((a at: index) at: 2)).
		self assert: (#(3 6) includes:((a at: index) at: 3)).].
	self deny: (((a at: 1)at: 2)=((a at: 2)at: 2)).
	self deny: (((a at: 1)at: 1)=((a at: 2)at: 1)).
	self deny: (((a at: 1)at: 3)=((a at: 2)at: 3)).
	a].
a:= a collect: [:g|g first].
self assert: ((a occurrencesOf: #(1 2 3))<20).! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 10:48'!
testEirCrossOver
|a|
a :=(1 to: 200)collect: [:i| a:=cm eirCrossover: #(1.0 3.0) and: #(5.0 1.0).
		self assert: (((a at: 1)at:1) between: -1 and: 7).
		self assert: (((a at: 1)at:2) between: 0 and: 4).
		self assert: (((a at: 2)at:1) between: -1 and: 3).
		self assert: (((a at: 2)at:2) between: 2 and: 4).
		a].
self assert: (a anySatisfy: [:g|((g at: 1)at:1)<0]).
self assert: (a anySatisfy: [:g|((g at: 1)at:1)>6]).
self assert: (a anySatisfy: [:g|((g at: 1)at:2)<1]).
self assert: (a anySatisfy: [:g|((g at: 1)at:2)>3]).
self assert: (a anySatisfy: [:g|((g at: 2)at:1)<0]).
self assert: (a anySatisfy: [:g|((g at: 2)at:1)>2]).
self assert: (a anySatisfy: [:g|((g at: 2)at:2)<3]).
self assert: (a anySatisfy: [:g|((g at: 2)at:2)>3]).
self shouldnt: [a:=cm eirCrossover: #(1 -3) and: #(1 -3)] raise: Error.
(1 to: 20)do: [:i| a:=cm eirCrossover: #(-1.0 -1) and: #(1 1.0).
		self assert: (((a at: 1)at:1) between: -2 and: 2).
		self assert: (((a at: 1)at:2) between: -2 and: 2).
		self assert: (((a at: 2)at:1) between: -2 and: 0).
		self assert: (((a at: 2)at:2) between: -2 and: 0).
		].	
! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'wk 6/21/2014 08:57'!
testIntegerDigits
self assert: ((AnotherChromosomeManager integerDigitsFor: 0 base: 2)= #(0)).
self assert: ((AnotherChromosomeManager integerDigitsFor: 1 base: 3)= #(1)).
self assert: ((AnotherChromosomeManager integerDigitsFor: 12 base: 2)= #(1 1 0 0)).
self assert: ((AnotherChromosomeManager integerDigitsFor: 12 base: 4)= #(3 0)).
self assert: ((AnotherChromosomeManager integerDigitsFor: 49 base: 5)= #(1 4 4)).
! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'wernerkassens 10/29/2014 16:12'!
testMutateProbabilistic
|a f s|
a:=(1 to: 100)collect:  [:i| cm mutate: #(-4 4)].
f:=a collect: [:i|i first].
s :=f select:[:i|i>(-4)].
self assert: (s size between: 15 and: 60).
s :=f select:[:i|i=(-4)].
self assert: (s size >20).
s :=f select:[:i|i>(-3.8)or:[i<(-4.2)]].
self assert: (s size between: 3 and: 20).
s :=f select:[:i|i>(-3.9)or:[i<(-4.1)]].
self assert: (s size between: 6 and: 50).

f:=a collect: [:i|i second ].
s :=f select:[:i|i>(4)].
self assert: (s size between: 15 and: 60).
s :=f select:[:i|i=(4)].
self assert: (s size >20).
s :=f select:[:i|i<(3.8)or:[i>(4.2)]].
self assert: (s size between: 3 and: 20).
! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'wk 6/21/2014 17:47'!
testPrint
|aStream  s|
aStream :=ReadWriteStream with:''.
cm printOn: aStream .
s :=aStream contents .
self assert: ((s findString: '#(0 1)')>0).
self assert: ((s findString: '#(2 3)')>0).
! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 10:51'!
testProcessand
cm reset.
1 to: 60 do:[:i| cm process: #(0 0) and:#(1 1) ].
self assert: ((cm population select: [:i|i=#(0 0)])size <15).
self assert: ((cm population select: [:i|i=#(1 1)])size <15).
self assert: ((cm population select: [:i|i=#(0 1)])size >0).
self assert: ((cm population select: [:i|i=#(1 0)])size >0).
self assert: (cm population size =120).
! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'wk 6/21/2014 11:38'!
testRandomizePopulation
|g|
self setHammersleyTest: true.
g :=cm population first.
self setHammersleyTest: false.
self deny: (cm population first =g).
g :=cm population first.
self setHammersleyTest: false.
self deny: (cm population first =g).
! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'WernerKassens 9/6/2014 10:48'!
testRateSetting
self should: [cm rateOfLC: 1.3] raise:  DomainError .
self should: [cm rateOfEir: -0.3] raise:  DomainError .
self should: [cm rateOfMutation:  1.0000003] raise:  DomainError .
self should: [cm rateOfCrossover:  -0.0000003] raise:  DomainError .
self shouldnt: [cm rateOfLC: 0] raise:  Error .
self should: [cm rateOfLC: 0.33] raise:  Warning  .
cm rateOfLC: 0.2.
self shouldnt: [cm rateOfEir: 0.25] raise:  Error  .
self should: [cm rateOfEir: 0.26] raise:  Warning    .
self should: [cm rateOfMutation: 1] raise:  Warning .
"usual floating point inaccuracies should be accepted:"
self shouldnt: [cm rateOfCrossover:  0.15000000000000001 ] raise:  Warning .
self should: [cm rateOfCrossover:  0.1500001] raise:  Warning .
! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 10:51'!
testlineCrossOver
|a|
1 to: 10 do: [:i| a:=cm lineCrossOver: #(-2 2) and: #(-4 4).
	self assert:( ((a at: 1)at: 2)= ((a at: 1)at: 1)negated ).
	self assert:( ((a at: 2)at: 2)=((a at: 2)at: 1)negated ).].
! !

!AnotherChromosomeManagerTest methodsFor: 'tests' stamp: 'wk 6/21/2014 09:34'!
testnumberOfHamersleyPoints
|rand|
self assert: ((AnotherChromosomeManager numberOfHamersleyPoints: 9 dimension: 1 randomized: false)= ((1 to:9)collect: [:i|{i*(1/9)}])).
self assert: ((AnotherChromosomeManager numberOfHamersleyPoints: 9 dimension: 4 randomized: false)= {{(1/9). (1/2). (1/3). (1/5)}. {(2/9). (1/4). (2/3). (2/5)}. {(1/3). (3/4). (1/9). (3/5)}. {(4/9). (1/8). (4/9). (4/5)}. {(5/9). (5/8). (7/9). (1/25)}. {(2/3). (3/8). (2/9). (6/25)}. {(7/9). (7/8). (5/9). (11/25)}. {(8/9). (1/16). (8/9). (16/25)}. {1. (9/16). (1/27). (21/25)}} ).
rand:=(AnotherChromosomeManager numberOfHamersleyPoints: 3 dimension: 4 randomized: false )-(AnotherChromosomeManager numberOfHamersleyPoints: 3 dimension: 4 randomized: true).
rand do: [:i| self assert:( i first >=0).self assert:( (i at: 2) <0).self assert:((i at: 3) <0)].
rand do:[:i|i do:[:j| j<(1/3)]].! !

TestCase subclass: #AnotherGeneticOptimizerTest
	instanceVariableNames: 'go'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-FunctionFit'!

!AnotherGeneticOptimizerTest methodsFor: 'running' stamp: 'wk 6/26/2014 00:37'!
setUp 
|origin f|
f:=[:x| |v| v:=x asDhbVector . v*v].
origin:= #(-5 -5 -5).
go:= AnotherGeneticOptimizer function: f minimumValues: origin maximumValues: origin negated .
go maximumIterations: 50.
go chromosomeManager populationSize: 20.! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'wk 6/22/2014 13:58'!
testChromosomeManager
self assert: (go chromosomeManager class =AnotherChromosomeManager ).
self assert: (go chromosomeManager populationSize=20).! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'WernerKassens 9/5/2014 23:58'!
testComputePrecision
|r|
go maximumIterations: 2.
go evaluate .
r:=go computePrecision:0.
go maximumIterations: 50 .
go evaluate .
self assert: (r>go computePrecision  ).
! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'wk 6/22/2014 16:39'!
testEvaluate
go maximumIterations: 170.
go chromosomeManager populationSize: 50.
self assert: (go evaluate equalsTo: #(0 0 0)  ).
! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 10:50'!
testInitializeIterations
self assert: (go bestPoints isEmpty ).
go initializeIterations .
self deny: (go bestPoints isEmpty ). 
go calcStatistics: true.
go evaluate .
self deny: (go bestValueHistory isEmpty  ).
go initializeIterations .
self assert: (go bestValueHistory isEmpty  ).


! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'wk 6/22/2014 18:44'!
testPrint
|aStream  s|
aStream :=ReadWriteStream with:''.
go printOn: aStream .
s :=aStream contents .
self assert: ((s findString: 'v * v')>0).
self assert: ((s findString: '50')>0).
self assert: ((s findString: '20')>0).! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 10:54'!
testRangeScale
go initializeIterations.
self assert: (go rangeScale first equalsTo: 0.1).
self assert: (go rangeScale second equalsTo: 0.19473684210526315).
go initializeIterations.
self assert: (go rangeScale first equalsTo: 0.1).
self assert: (go rangeScale second equalsTo: 0.19473684210526315).
! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 10:49'!
testRangeScaleProbabilistic
	| r1 r2 correct |
	correct := 0.
	9
		timesRepeat: [ 
			self setUp.
			go maximumIterations: 500.
			go rangeScale: true.
			r1 := go evaluate norm.
			self setUp.
			go maximumIterations: 500.
			go rangeScale: false.
			r2 := go evaluate norm.
			correct := r1 < r2
				ifTrue: [ correct + 1 ]
				ifFalse: [ correct - 1 ] ].
	self assert: correct > 0! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 10:49'!
testRemoveLastProbabilistic
	| r1 r2 correct |
	correct := 0.
	3
		timesRepeat: [ 
			self setUp.
			go maximumIterations: 1000.
			go removeLast: true.
			r1 := go evaluate norm.
			self setUp.
			go maximumIterations: 1000.
			go removeLast: false.
			r2 := go evaluate norm.
			correct := r1 > r2
				ifTrue: [ correct + 1 ]
				ifFalse: [ correct - 1 ] ].
	self assert: correct > 0! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'wk 6/22/2014 16:07'!
testSteadyState
|r1 r2|
"probabilistic test. not always true"
go steadyState:  false.
go maximumIterations: 1000.
r1 :=go evaluate norm.
self setUp .
go steadyState:  true.
go maximumIterations: 1000.
r2 :=go evaluate norm.
self assert: (r1>r2  ).
! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'wk 6/26/2014 13:30'!
testaddPointAt
| b |
go chromosomeManager populationSize: 2.
go resetBestPoints .
go addPointAt: #(0 1 0).
b:=go bestPoints.
self assert: (b first position=#(0 1 0)  ).
self assert: (b first value=1  ).
go addPointAt: {0 . Float nan.0}.
self assert: (go bestPoints=b  ).
go addPointAt: {(0-Float infinity) . 0. 0}.
self assert: (go bestPoints=b  ).
go addPointAt: #(1 1 0).
b:=go bestPoints.
self assert: (b size=2).
go addPointAt: #(2 1 0).
self assert: (go bestPoints=b  ).
go addPointAt: #(0 0.9 0).
self assert: (b first position=#(0 0.9 0)  ).
self assert: (b second position=#(0 1 0)  )."never throw away old first position"
go removeLast: true.
go addPointAt: #(0 0.89 0).
self assert: (b first position=#(0 0.89 0)  ).
self assert: (b second position=#(0 0.9 0)  ).



! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'WernerKassens 9/6/2014 10:12'!
testcalcStatistics
|s|
go evaluate .
self assert: (go bestValueHistory isEmpty  ).
self assert: (go worstValueHistory isEmpty).
self assert: (go whateverHistory isEmpty).
go calcStatistics: true.
go evaluate .
s:=go iterations.
self assert: (go bestValueHistory size = s ).
self assert: (go worstValueHistory size=s).
self assert: (go whateverHistory size=s).
! !

!AnotherGeneticOptimizerTest methodsFor: 'tests' stamp: 'wk 6/22/2014 16:56'!
testresetBestPoints
go evaluate .
go resetBestPoints .
self assert: (go bestPoints isEmpty  ).
! !

TestCase subclass: #DataHolderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-FunctionFit'!

!DataHolderTest methodsFor: 'tests' stamp: 'wk 6/14/2014 12:48'!
testpointsAndErrorsDo
|g|
g:=DataHolder new: 2 withAll: 2@3.
g pointsAndErrorsDo: [:i|( i xValue =2)ifFalse:[self error].( i yValue =3)ifFalse:[self error].( i weight=1)ifFalse:[self error]].! !

TestCase subclass: #ErrorAsParameterFunctionTest
	instanceVariableNames: 'f'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-FunctionFit'!

!ErrorAsParameterFunctionTest methodsFor: 'running' stamp: 'WernerKassens 6/23/2014 11:00'!
setUp 
|col|
f:=ErrorOfParameterFunction new function: [:x :a :b|a*x / (b+x)].
col:=(1 to: 3)collect: [:i|i@(f function cull: i cull: 1 cull: 1) ].
f data: col.
f :=ErrorAsParameterFunction new function: f.! !

!ErrorAsParameterFunctionTest methodsFor: 'tests' stamp: 'wk 6/19/2014 14:29'!
testMaxFunction
self assert: (f parameters size < f maxFunction ).
! !

!ErrorAsParameterFunctionTest methodsFor: 'tests' stamp: 'wk 6/19/2014 14:41'!
testPrint
|aStream  s|
aStream :=ReadWriteStream with:''.
f printOn: aStream .
s :=aStream contents .
self assert: ((s findString: 'a * x / (b + x)')>0).
self assert: ((s findString: '#squared')>0).
self assert: ((s findString: 'maxFunction: ', f maxFunction asString )>0).

! !

!ErrorAsParameterFunctionTest methodsFor: 'tests' stamp: 'wk 6/19/2014 14:31'!
testparameters
f parameters:#(1 1).
f changeParametersBy:#(1 1).
self assert: (f parameters= #(2 2) ).
! !

!ErrorAsParameterFunctionTest methodsFor: 'tests' stamp: 'wk 6/19/2014 14:39'!
testvalue
f parameters:#(2 2).
self assert: ((f value:2) = (1/9) ).
! !

TestCase subclass: #ErrorMinimizerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-FunctionFit'!

!ErrorMinimizerTest commentStamp: 'wk 6/15/2014 13:38' prior: 0!
ErrorMinimizerTest tests indirectly also ErrorAsParameterFunction.!

!ErrorMinimizerTest methodsFor: 'tests' stamp: 'wk 6/15/2014 13:43'!
testErrorMinimzer
|f col er fit|
f:=[:x :a :b|a*x / (b+x)].
col:=(0 to: 20)collect: [:i|i@(f cull: i cull: 2 cull: 0.4) ].
er:=ErrorOfParameterFunction function: f data: col.
er errorType: #insensitive.
er quartile: 0.9.
fit:= ErrorMinimizer function: er.
fit evaluate .
self assert: (fit  maxFunction>2) .
self assert: (fit parameters equalsTo: #(2 0.4))! !

TestCase subclass: #ErrorOfParameterFunctionTest
	instanceVariableNames: 'f col'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-FunctionFit'!

!ErrorOfParameterFunctionTest methodsFor: 'running' stamp: 'wk 6/15/2014 09:01'!
setUp
f:=ErrorOfParameterFunction new function: [:x :a :b|a*x / (b+x)].
col:=(1 to: 3)collect: [:i|i@(f function cull: i cull: 1 cull: 1) ].
! !

!ErrorOfParameterFunctionTest methodsFor: 'tests' stamp: 'wk 6/24/2014 22:16'!
testArgumentsString
self assert: (f parameterNames = #('a' 'b') asOrderedCollection ).! !

!ErrorOfParameterFunctionTest methodsFor: 'tests' stamp: 'wk 6/15/2014 09:03'!
testErrorCollection
f data: col.
f errorType: #squared.
self assert: ((f errorCollection:#(0 1))= {(1/4). (4/9). (9/16)}).
f errorType: #abs.
self assert:((f errorCollection:#(0 1))={(1/2). (2/3). (3/4)}). 
f errorType: #median.
self assert:((f errorCollection:#(1 1))=#(0 0 0)). 
! !

!ErrorOfParameterFunctionTest methodsFor: 'tests' stamp: 'wk 6/14/2014 18:44'!
testErrorType
self assert: (f errorType = #squared).
f errorType: #abs.
self assert: (f errorType = #abs).
self should: [f errorType: #square] raise: MessageNotUnderstood .
self should: [f errorType: 'squared'] raise: MessageNotUnderstood .
f quartile: (1/4).
f errorType: #median.
self assert: (f errorType = #quartile).
self assert: (f quartile =(1/2)).

! !

!ErrorOfParameterFunctionTest methodsFor: 'tests' stamp: 'wk 6/14/2014 18:34'!
testFunction
self assert: ((f function cull:1 cull:2 cull:3) =(1/2)).
self assert: (f parameterSize  =2).
! !

!ErrorOfParameterFunctionTest methodsFor: 'tests' stamp: 'WernerKassens 6/15/2014 10:13'!
testPrint
|aStream  s|
aStream :=ReadWriteStream with:''.
f data:{(1@(1/2)). (2@(2/3)). (3@(3/4))} .
f printOn: aStream .
s :=aStream contents .
self assert: ((s findString: 'a * x / (b + x)')>0).
self assert: ((s findString: 'squared')>0).
self assert: ((s findString: 'false')>0).

! !

!ErrorOfParameterFunctionTest methodsFor: 'tests' stamp: 'wk 6/15/2014 08:30'!
testQuartile
self assert: (f quartile =(1/2)).
f quartile: 1.
self assert: (f quartile =1). 
self should: [f quartile: 2] raise: DomainError .
self should: [f quartile: (-0.1)] raise: DomainError .
! !

!ErrorOfParameterFunctionTest methodsFor: 'tests' stamp: 'WernerKassens 6/17/2014 17:49'!
testRealValue
f:=ErrorOfParameterFunction function: [ :i :a|i+a ] data: { 1@1. 2@2 }.
f errorType: #squared.
self assert:((f realValue:#(-2))=2 ). 
f errorType: #abs.
self assert:((f realValue:#(-2))=2). 
f errorType: #median.
self assert:((f realValue:#(-2))=2). 
f relativeError: true.
f errorType: #squared.
self assert:((f realValue:#(-2))=(5/2)sqrt ). 
f errorType: #abs.
self assert:((f realValue:#(-2))= (3/2)). 
f errorType: #median.
self assert:((f realValue:#(-2))=1 ).
! !

!ErrorOfParameterFunctionTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 11:02'!
testdata
	self assert: f data isNil.
	f data: col.
	self assert: f data = col! !

!ErrorOfParameterFunctionTest methodsFor: 'tests' stamp: 'wk 6/15/2014 09:41'!
testvalue
f data: col.
f errorType: #squared.
self assert:((f value:#(0 1))=(181/144) ). 
f errorType: #abs.
self assert:((f value:#(0 1))=(23/12)). 
f errorType: #median.
self assert:((f value:#(0 1))=(2/3)). 
f data: (col copyFrom: 1 to: 2).
self assert:((f value:#(0 1))=(1/2)).
f quartile: 1.
self assert:((f value:#(0 1))=(2/3)). 
f quartile: 0.
self assert:((f value:#(0 1))=(1/2)). 
f errorType: #squared.
self assert:((f realValue:#(0 0))=(25/72)sqrt). ! !

TestCase subclass: #FunctionFitTest
	instanceVariableNames: 'f d'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-FunctionFit'!

!FunctionFitTest methodsFor: 'running' stamp: 'wk 6/14/2014 16:12'!
setUp 
f:=[:x :a :b|a*x / (b+x)].
d:=(1 to: 20)collect: [:i|i@(f cull: i cull: 2 cull: 0.4) ].! !

!FunctionFitTest methodsFor: 'tests' stamp: 'wk 6/14/2014 17:15'!
testFunctionFit
|ff ar p| 
ff:=  FunctionFit function: f data: d .
ar :=ff parameters .
ar do: [:i| self assert: (i isNumber ).self assert: (i ~= 0)].
ff parameters: #(1 2).
self assert: (ff parameters =#(1 2)).
p :=DhbWeightedPoint point:((-2)@1).
self shouldnt: [ff accumulate: p] raise: Error . "function result will be NaN and should be ignored in the following calculations"
ff parameters: ar.
ff evaluate .
self assert: (ff parameters equalsTo: #(2 0.4)).

! !

!FunctionFitTest methodsFor: 'tests' stamp: 'WernerKassens 6/15/2014 10:10'!
testPrint
|aStream ff s|
aStream :=ReadWriteStream with:''.
ff:=  FunctionFit function: f data: d .
ff printOn: aStream .
s :=aStream contents .
self assert: ((s findString: 'a * x / (b + x)')>0).
self assert: ((s findString: '20')>0).

! !

TestCase subclass: #GeneralFunctionFitTest
	instanceVariableNames: 'f col'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-FunctionFit'!

!GeneralFunctionFitTest methodsFor: 'running' stamp: 'wk 6/17/2014 12:28'!
setUp 
f:=[ :x :a :b | (a * x) sin / (b + x squared) ].
col:=((-4) to: 4 by:0.1)collect: [:i|i@(f cull: i cull: 0.1 cull: 0.4) ].! !

!GeneralFunctionFitTest methodsFor: 'tests' stamp: 'wk 6/17/2014 14:42'!
testBasic
|fit d|
fit:=GeneralFunctionFit function: f data: col minimumValues: 0 maximumValues: 5 .
self assert: (fit evaluate equalsTo:  #(0.1 0.4)).
(fit result - #(0.1 0.4))abs with: (fit secondaryResult - #(0.1 0.4))abs do:
	 [:e :s| self assert: (s -e > 0)].
d:=fit error:fit secondaryResult.
self assert: (d<1e-5).
self assert: (fit error<d).


! !

!GeneralFunctionFitTest methodsFor: 'tests' stamp: 'wk 6/19/2014 16:37'!
testFunction 
|fit y|
fit:=GeneralFunctionFit function: f data: col minimumValues: 0 maximumValues: 5 .
y:=fit function  value: 3 value: 0.1 value: 0.4.
fit evaluate .
self assert: ((fit function value:3) equalsTo:  y).



! !

!GeneralFunctionFitTest methodsFor: 'tests' stamp: 'wk 6/19/2014 16:47'!
testManager
|fit|
fit:=GeneralFunctionFit function: f data: col minimumValues: 0 maximumValues: 5 .
self assert: (fit manager class =AnotherChromosomeManager ).
self assert: (fit manager range= #(5 5)).


! !

!GeneralFunctionFitTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 10:50'!
testMaximumIterationsProbabilistic
	| fit r correct |
	fit := GeneralFunctionFit
		function: f
		data: col
		minimumValues: 0
		maximumValues: 5.
	correct := 0.
	fit populationSize: 20.
	7
		timesRepeat: [ 
			fit resetBestPoints.
			fit maximumIterations: 200.
			r := (fit evaluate - #(0.1 0.4)) abs.
			fit resetBestPoints.
			fit maximumIterations: 2.
			r := (fit evaluate - #(0.1 0.4)) abs - r.
			correct := ((r at: 1) > 0 or: [ (r at: 2) > 0 ])
				ifTrue: [ correct + 1 ]
				ifFalse: [ correct - 1 ] ].
	self assert: correct > 0! !

!GeneralFunctionFitTest methodsFor: 'tests' stamp: 'wk 6/19/2014 16:49'!
testPopulationSize
|fit|
fit:=GeneralFunctionFit function: f data: col minimumValues: 0 maximumValues: 5 .
self assert: (fit manager populationSize= 50 ).
fit populationSize: 100.
self assert: (fit manager populationSize= 100 ).


! !

!GeneralFunctionFitTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 11:03'!
testPrecision
|fit|
fit:=GeneralFunctionFit function: f data: col minimumValues: 0 maximumValues: 5 .
self assert:fit precision isNil.
fit evaluate .
self assert: (fit precision < 1e-6 ).


! !

!GeneralFunctionFitTest methodsFor: 'tests' stamp: 'wk 6/19/2014 17:04'!
testPrint
|aStream s fit|
fit:=GeneralFunctionFit function: f data: col minimumValues: 0 maximumValues: 5 .
aStream :=ReadWriteStream with:''.
fit printOn: aStream .
s :=aStream contents .
self assert: ((s findString: '(a * x) sin / (b + x squared)')>0).
self assert: ((s findString: '#squared')>0).
self assert: ((s findString: '81')>0).
self assert: ((s findString: '#(0.')=0).
fit evaluate .
aStream :=ReadWriteStream with:''.
fit printOn: aStream .
s :=aStream contents .
self assert: ((s findString: '#(0.')>0).! !

!GeneralFunctionFitTest methodsFor: 'tests' stamp: 'wk 6/20/2014 09:36'!
testRelativeError
|fit r|
f:=[ :x :a| a].
col:={1@2. 2@6}.
fit:=GeneralFunctionFit function: f data: col minimumValues: -6 maximumValues: 6 .
fit populationSize: 10.
r :=fit evaluate first .
self assert: (r equalsTo: 4 ).
fit errorType: #abs.
fit relativeError: true.
r :=fit evaluate first .
self assert: ((r - (2*6)sqrt)abs<1e-5 ).
fit errorType: #squared.
r :=fit evaluate first .
self assert: (r>(2*6)sqrt ).
self assert: (r<4 ).




! !

!GeneralFunctionFitTest methodsFor: 'tests' stamp: 'wk 6/19/2014 17:18'!
testResetBestPoints
|fit|
fit:=GeneralFunctionFit function: f data: col minimumValues: 0 maximumValues: 5 .
fit evaluate .
fit resetBestPoints.
self assert: (fit optimizer bestPoints isEmpty ).! !

!GeneralFunctionFitTest methodsFor: 'tests' stamp: 'WernerKassens 6/23/2014 11:25'!
testTruncate
|fit|
col at:1 put: (-4@ -0.2).
col at: 81put: (4.000000000000004@0.2).
col at: 10 put: (-3.099999999999999@ 2).
fit:=GeneralFunctionFit function: f data: col minimumValues: 0 maximumValues: 5 .
fit errorType: #quartile.
self assert: (fit findQuartile equalsTo: #(0.1 0.4) ) .
self assert: (fit quartile < (79/81) ).
self assert: (fit quartile > (75/81) ).
self deny: (fit dataTruncated ).
fit truncateData .
self assert: (fit dataTruncated ).
self assert: (fit optimizer functionBlock data size= (fit quartile * col size) ).
fit errorType: #abs.
self assert: (fit errorType =#abs).
self assert: (fit evaluate equalsTo:  #(0.1 0.4)).
fit resetData .
self assert: (fit optimizer functionBlock data size= col size ).



! !

TestCase subclass: #SimpleParameterFunctionTest
	instanceVariableNames: 'f'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-FunctionFit'!

!SimpleParameterFunctionTest methodsFor: 'running' stamp: 'WernerKassens 6/14/2014 11:55'!
setUp
	f:=[:a :x :cc :b|x].! !

!SimpleParameterFunctionTest methodsFor: 'tests' stamp: 'WernerKassens 6/14/2014 12:01'!
testChangeParametersBy
|s | 
s:=SimpleParameterFunction function: f parameters: #(1 1 2).
s changeParametersBy: #(3 2 1).
self assert: (s parameters =#(4 3 3)).
! !

!SimpleParameterFunctionTest methodsFor: 'tests' stamp: 'WernerKassens 6/15/2014 09:50'!
testParameterNames
|s|
s:=SimpleParameterFunction function:f.
self assert: (s parameterNames asArray= #('x' 'cc' 'b')).! !

!SimpleParameterFunctionTest methodsFor: 'tests' stamp: 'WernerKassens 6/14/2014 12:13'!
testPrint
|aStream s|
aStream :=ReadWriteStream with:''.
s:=SimpleParameterFunction function:f parameters: #(1 2 3).
s printOn: aStream .
s :=aStream contents .
self assert: ((s findString: 'a SimpleParameterFunction')=1).
self assert: ((s findString: '1')>0).
self assert: ((s findString: ' 2')>0).
self assert: ((s findString: ' 3')>0).
! !

!SimpleParameterFunctionTest methodsFor: 'tests' stamp: 'WernerKassens 6/14/2014 11:56'!
testRest
|s vg| 
s:=SimpleParameterFunction function:f.
self assert: (s parameters size =3).
vg:=s valueAndGradient: 2.
self assert: (s parameters first =vg first).
self assert: (vg second equalsTo: #(1 0 0)).

s parameters: #(2 0 0).
self assert: ((s value: 0) =2).
self assert: (s parameters =#(2 0 0)).
self assert: (s parameterSize =3).! !
